! Copyright (C) TOYODA Eizi, 2000.  All rights reserved.

subroutine GTVarAddMember(var, member_url, link_name)
    use gtdata_types, only: GT_VARIABLE
    use dc_types, only: STRING
    use dc_url, only: UrlSplit
    use gtdata_generic, only: put_attr, get_attr
    use dc_error
    implicit none
    type(GT_VARIABLE), intent(inout):: var
    character(len = *), intent(in):: member_url
    character(len = *), intent(in), optional:: link_name
    character(len = string):: members, myshortname, conv
continue
    ! û̾Τη
    ! ¸Υ̾˽ʣʤΤ
    call get_attr(var, 'gt_structure_member', members)
    if (present(link_name)) then
        if (index(members, ' ' //link_name) == 0) then
            myshortname = link_name
            goto 1000
        endif
    endif
    conv = member_url
    call UrlSplit(conv, var=myshortname)
    ! fake Ƚ
    if (index(members, trim(myshortname)) /= 0) then
        call StoreError(GT_EFAKE, "GTVarAddMember(making unique name)")
    endif
    1000 continue
    members = trim(members) // ' ' // trim(myshortname)
    call put_attr(var, 'gt_structure_member', trim(members))
    myshortname = 'gt_structure_link_' // trim(myshortname)
    call put_attr(var, myshortname, trim(member_url))

end subroutine
